<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:07 +0000">

<link rel="stylesheet" type="text/css" href="../../../stylesheet.css">
<link rel="start" href="../../../overview-summary.html">

<title>doclets/standard/indexWriter.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../../overview-files.html">Files</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../todo-list.html">Todo</a></li>
<li><a href="../../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../../index.html" target="_top">Frames</a>
<a href="../../../source/doclets/standard/indexwriter.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>doclets/standard/indexWriter.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2005 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>/** This generates the element index.
<a name="line22"></a> *
<a name="line23"></a> * @package PHPDoctor\Doclets\Standard
<a name="line24"></a> */
<a name="line25"></a>class IndexWriter extends HTMLWriter
<a name="line26"></a>{
<a name="line27"></a>
<a name="line28"></a>	/** Build the element index.
<a name="line29"></a>	 *
<a name="line30"></a>	 * @param Doclet doclet
<a name="line31"></a>	 */
<a name="line32"></a>	function indexWriter(&$doclet)
<a name="line33"></a>    {
<a name="line34"></a>	
<a name="line35"></a>		parent::HTMLWriter($doclet);
<a name="line36"></a>		
<a name="line37"></a>		//$this->_id = 'definition';
<a name="line38"></a>        
<a name="line39"></a>		$rootDoc =& $this->_doclet->rootDoc();
<a name="line40"></a>        
<a name="line41"></a>        $this->_sections[0] = array('title' => 'Overview', 'url' => 'overview-summary.html');
<a name="line42"></a>        $this->_sections[1] = array('title' => 'Namespace');
<a name="line43"></a>        $this->_sections[2] = array('title' => 'Class');
<a name="line44"></a>        //$this->_sections[3] = array('title' => 'Use');
<a name="line45"></a>        $this->_sections[4] = array('title' => 'Tree', 'url' => 'overview-tree.html');
<a name="line46"></a>        if ($doclet->includeSource()) $this->_sections[5] = array('title' => 'Files', 'url' => 'overview-files.html');
<a name="line47"></a>        $this->_sections[6] = array('title' => 'Deprecated', 'url' => 'deprecated-list.html');
<a name="line48"></a>        $this->_sections[7] = array('title' => 'Todo', 'url' => 'todo-list.html');
<a name="line49"></a>        $this->_sections[8] = array('title' => 'Index', 'selected' => TRUE);
<a name="line50"></a>        
<a name="line51"></a>        $classes =& $rootDoc->classes();
<a name="line52"></a>        if($classes == NULL) $classes = array();
<a name="line53"></a>        
<a name="line54"></a>        $methods = array();
<a name="line55"></a>        foreach ($classes as $class) {
<a name="line56"></a>            foreach ($class->methods() as $name => $method) {
<a name="line57"></a>                $methods[$class->name().'::'.$name] = $method;
<a name="line58"></a>            }
<a name="line59"></a>        }
<a name="line60"></a>        if($methods == NULL) $methods = array();
<a name="line61"></a>        
<a name="line62"></a>        $functions =& $rootDoc->functions();
<a name="line63"></a>        if($functions == NULL) $functions = array();
<a name="line64"></a>        
<a name="line65"></a>        $globals =& $rootDoc->globals();
<a name="line66"></a>        if($globals == NULL) $globals = array();
<a name="line67"></a>        
<a name="line68"></a>        $elements = array_merge($classes, $methods, $functions, $globals);
<a name="line69"></a>        uasort($elements, array($this, 'compareElements'));
<a name="line70"></a>        
<a name="line71"></a>        ob_start();
<a name="line72"></a>        
<a name="line73"></a>        $letter = 64;
<a name="line74"></a>        foreach ($elements as $name => $element) {
<a name="line75"></a>            $firstChar = strtoupper(substr($element->name(), 0, 1));
<a name="line76"></a>            if (is_object($element) && $firstChar != chr($letter)) {
<a name="line77"></a>                $letter = ord($firstChar);
<a name="line78"></a>                echo '<a href="#letter', chr($letter), '">', chr($letter), "</a>\n";
<a name="line79"></a>            }
<a name="line80"></a>        }
<a name="line81"></a>
<a name="line82"></a>        echo "<hr>\n\n";
<a name="line83"></a>        
<a name="line84"></a>        $first = TRUE;
<a name="line85"></a>        foreach ($elements as $element) {
<a name="line86"></a>            if (is_object($element)) {
<a name="line87"></a>                if (strtoupper(substr($element->name(), 0, 1)) != chr($letter)) {
<a name="line88"></a>                    $letter = ord(strtoupper(substr($element->name(), 0, 1)));
<a name="line89"></a>                    if (!$first) {
<a name="line90"></a>                        echo "</dl>\n";
<a name="line91"></a>                    }
<a name="line92"></a>                    $first = FALSE;
<a name="line93"></a>                    echo '<h1 id="letter', chr($letter), '">', chr($letter), "</h1>\n";
<a name="line94"></a>                    echo "<dl>\n";
<a name="line95"></a>                }
<a name="line96"></a>                $parent =& $element->containingClass();
<a name="line97"></a>                if ($parent && strtolower(get_class($parent)) != 'rootdoc') {
<a name="line98"></a>                    $in = 'class <a href="'.$parent->asPath().'">'.$parent->qualifiedName().'</a>';
<a name="line99"></a>                } else {
<a name="line100"></a>                    $package =& $element->containingPackage();
<a name="line101"></a>                    $in = 'namespace <a href="'.$package->asPath().'/package-summary.html">'.$package->name().'</a>';
<a name="line102"></a>                }
<a name="line103"></a>                switch (strtolower(get_class($element))) {
<a name="line104"></a>                case 'classdoc':
<a name="line105"></a>                    if ($element->isOrdinaryClass()) {
<a name="line106"></a>                        echo '<dt><a href="', $element->asPath(), '">', $element->name(), '()</a> - Class in ', $in, "</dt>\n";
<a name="line107"></a>                    } elseif ($element->isInterface()) {
<a name="line108"></a>                        echo '<dt><a href="', $element->asPath(), '">', $element->name(), '()</a> - Interface in ', $in, "</dt>\n";
<a name="line109"></a>                    } elseif ($element->isException()) {
<a name="line110"></a>                        echo '<dt><a href="', $element->asPath(), '">', $element->name(), '()</a> - Exception in ', $in, "</dt>\n";
<a name="line111"></a>                    }
<a name="line112"></a>                    break;
<a name="line113"></a>                case 'methoddoc':
<a name="line114"></a>                    if ($element->isMethod()) {
<a name="line115"></a>                        echo '<dt><a href="', $element->asPath(), '">', $element->name(), '()</a> - Method in ', $in, "</dt>\n";
<a name="line116"></a>                    } elseif ($element->isFunction()) {
<a name="line117"></a>                        echo '<dt><a href="', $element->asPath(), '">', $element->name(), '()</a> - Function in ', $in, "</dt>\n";
<a name="line118"></a>                    }
<a name="line119"></a>                    break;
<a name="line120"></a>                case 'fielddoc':
<a name="line121"></a>                    if ($element->isGlobal()) {
<a name="line122"></a>                        echo '<dt><a href="', $element->asPath(), '">', $element->name(), '()</a> - Global in ', $in, "</dt>\n";
<a name="line123"></a>                    }
<a name="line124"></a>                    break;
<a name="line125"></a>                }
<a name="line126"></a>                if ($textTag =& $element->tags('@text') && $firstSentenceTags =& $textTag->firstSentenceTags($this->_doclet)) {
<a name="line127"></a>                    echo '<dd>';
<a name="line128"></a>                    foreach ($firstSentenceTags as $firstSentenceTag) {
<a name="line129"></a>                        echo $firstSentenceTag->text($this->_doclet);
<a name="line130"></a>                    }
<a name="line131"></a>                    echo "</dd>\n";
<a name="line132"></a>                }
<a name="line133"></a>            }
<a name="line134"></a>        }
<a name="line135"></a>        echo "</dl>\n";
<a name="line136"></a>                
<a name="line137"></a>        $this->_output = ob_get_contents();
<a name="line138"></a>        ob_end_clean();
<a name="line139"></a>
<a name="line140"></a>        $this->_write('index-all.html', 'Index', TRUE);
<a name="line141"></a>	
<a name="line142"></a>	}
<a name="line143"></a>    
<a name="line144"></a>    function compareElements($element1, $element2)
<a name="line145"></a>    {
<a name="line146"></a>        $e1 = strtolower($element1->name());
<a name="line147"></a>        $e2 = strtolower($element2->name());
<a name="line148"></a>        if ($e1 == $e2) {
<a name="line149"></a>            return 0;
<a name="line150"></a>        } elseif ($e1 < $e2) {
<a name="line151"></a>            return -1;
<a name="line152"></a>        } else {
<a name="line153"></a>            return 1;
<a name="line154"></a>        }
<a name="line155"></a>    }
<a name="line156"></a>
<a name="line157"></a>}
<a name="line158"></a>
<a name="line159"></a>?>
<a name="line160"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../../overview-files.html">Files</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../todo-list.html">Todo</a></li>
<li><a href="../../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../../index.html" target="_top">Frames</a>
<a href="../../../source/doclets/standard/indexwriter.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>